/* Generated by wayland-scanner 1.19.0 */

#ifndef QTAM_EXTENSION_CLIENT_PROTOCOL_H
#define QTAM_EXTENSION_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_qtam_extension The qtam_extension protocol
 * @section page_ifaces_qtam_extension Interfaces
 * - @subpage page_iface_qtam_extension - 
 * @section page_copyright_qtam_extension Copyright
 * <pre>
 *
 * Copyright (C) 2019 Luxoft Sweden AB
 * Copyright (C) 2018 Pelagicore AG
 * Contact: https://www.qt.io/licensing/
 *
 * This file is part of the Qt Application Manager.
 *
 * $QT_BEGIN_LICENSE:BSD-QTAS$
 * Commercial License Usage
 * Licensees holding valid commercial Qt Automotive Suite licenses may use
 * this file in accordance with the commercial license agreement provided
 * with the Software or, alternatively, in accordance with the terms
 * contained in a written agreement between you and The Qt Company.  For
 * licensing terms and conditions see https://www.qt.io/terms-conditions.
 * For further information use the contact form at https://www.qt.io/contact-us.
 *
 * BSD License Usage
 * Alternatively, you may use this file under the terms of the BSD license
 * as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 *
 * SPDX-License-Identifier: BSD-3-Clause
 * </pre>
 */
struct qtam_extension;
struct wl_surface;

#ifndef QTAM_EXTENSION_INTERFACE
#define QTAM_EXTENSION_INTERFACE
/**
 * @page page_iface_qtam_extension qtam_extension
 * @section page_iface_qtam_extension_api API
 * See @ref iface_qtam_extension.
 */
/**
 * @defgroup iface_qtam_extension The qtam_extension interface
 */
extern const struct wl_interface qtam_extension_interface;
#endif

/**
 * @ingroup iface_qtam_extension
 * @struct qtam_extension_listener
 */
struct qtam_extension_listener {
	/**
	 */
	void (*window_property_changed)(void *data,
					struct qtam_extension *qtam_extension,
					struct wl_surface *surface,
					const char *name,
					struct wl_array *value);
};

/**
 * @ingroup iface_qtam_extension
 */
static inline int
qtam_extension_add_listener(struct qtam_extension *qtam_extension,
			    const struct qtam_extension_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qtam_extension,
				     (void (**)(void)) listener, data);
}

#define QTAM_EXTENSION_SET_WINDOW_PROPERTY 0

/**
 * @ingroup iface_qtam_extension
 */
#define QTAM_EXTENSION_WINDOW_PROPERTY_CHANGED_SINCE_VERSION 1

/**
 * @ingroup iface_qtam_extension
 */
#define QTAM_EXTENSION_SET_WINDOW_PROPERTY_SINCE_VERSION 1

/** @ingroup iface_qtam_extension */
static inline void
qtam_extension_set_user_data(struct qtam_extension *qtam_extension, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qtam_extension, user_data);
}

/** @ingroup iface_qtam_extension */
static inline void *
qtam_extension_get_user_data(struct qtam_extension *qtam_extension)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qtam_extension);
}

static inline uint32_t
qtam_extension_get_version(struct qtam_extension *qtam_extension)
{
	return wl_proxy_get_version((struct wl_proxy *) qtam_extension);
}

/** @ingroup iface_qtam_extension */
static inline void
qtam_extension_destroy(struct qtam_extension *qtam_extension)
{
	wl_proxy_destroy((struct wl_proxy *) qtam_extension);
}

/**
 * @ingroup iface_qtam_extension
 */
static inline void
qtam_extension_set_window_property(struct qtam_extension *qtam_extension, struct wl_surface *surface, const char *name, struct wl_array *value)
{
	wl_proxy_marshal((struct wl_proxy *) qtam_extension,
			 QTAM_EXTENSION_SET_WINDOW_PROPERTY, surface, name, value);
}

#ifdef  __cplusplus
}
#endif

#endif
