// This file was generated by qtwaylandscanner
// source file is /builddir/build/BUILD/qtapplicationmanager-5.15.1_QtAS/src/wayland-extensions/qtam-extension.xml

#include <QtAppManWindow/private/qwayland-server-qtam-extension.h>

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWaylandServer {
    qtam_extension::qtam_extension(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(client, id, version);
    }

    qtam_extension::qtam_extension(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(display, version);
    }

    qtam_extension::qtam_extension(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(resource);
    }

    qtam_extension::qtam_extension()
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
    }

    qtam_extension::~qtam_extension()
    {
        for (auto resource : qAsConst(m_resource_map))
            resource->qtam_extension_object = nullptr;

        if (m_resource)
            m_resource->qtam_extension_object = nullptr;

        if (m_global) {
            wl_global_destroy(m_global);
            wl_list_remove(&m_displayDestroyedListener.link);
        }
    }

    void qtam_extension::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void qtam_extension::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    qtam_extension::Resource *qtam_extension::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    qtam_extension::Resource *qtam_extension::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void qtam_extension::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::qtam_extension_interface, version, this, bind_func);
        m_globalVersion = version;
        m_displayDestroyedListener.notify = qtam_extension::display_destroy_func;
        m_displayDestroyedListener.parent = this;
        wl_display_add_destroy_listener(display, &m_displayDestroyedListener);
    }

    const struct wl_interface *qtam_extension::interface()
    {
        return &::qtam_extension_interface;
    }

    qtam_extension::Resource *qtam_extension::qtam_extension_allocate()
    {
        return new Resource;
    }

    void qtam_extension::qtam_extension_bind_resource(Resource *)
    {
    }

    void qtam_extension::qtam_extension_destroy_resource(Resource *)
    {
    }

    void qtam_extension::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        qtam_extension *that = static_cast<qtam_extension *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void qtam_extension::display_destroy_func(struct ::wl_listener *listener, void *data)
    {
        Q_UNUSED(data);
        qtam_extension *that = static_cast<qtam_extension::DisplayDestroyedListener *>(listener)->parent;
        that->m_global = nullptr;
    }

    void qtam_extension::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        Q_ASSERT(resource);
        qtam_extension *that = resource->qtam_extension_object;
        if (Q_LIKELY(that)) {
            that->m_resource_map.remove(resource->client(), resource);
            that->qtam_extension_destroy_resource(resource);

            that = resource->qtam_extension_object;
            if (that && that->m_resource == resource)
                that->m_resource = nullptr;
        }
        delete resource;
    }

    qtam_extension::Resource *qtam_extension::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::qtam_extension_interface, version, id);
        return bind(handle);
    }

    qtam_extension::Resource *qtam_extension::bind(struct ::wl_resource *handle)
    {
        Resource *resource = qtam_extension_allocate();
        resource->qtam_extension_object = this;

        wl_resource_set_implementation(handle, &m_qtam_extension_interface, resource, destroy_func);
        resource->handle = handle;
        qtam_extension_bind_resource(resource);
        return resource;
    }
    qtam_extension::Resource *qtam_extension::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (Q_UNLIKELY(!resource))
            return nullptr;
        if (wl_resource_instance_of(resource, &::qtam_extension_interface, &m_qtam_extension_interface))
            return static_cast<Resource *>(wl_resource_get_user_data(resource));
        return nullptr;
    }

    const struct ::qtam_extension_interface qtam_extension::m_qtam_extension_interface = {
        qtam_extension::handle_set_window_property
    };

    void qtam_extension::qtam_extension_set_window_property(Resource *, struct ::wl_resource *, const QString &, wl_array *)
    {
    }


    void qtam_extension::handle_set_window_property(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *surface,
        const char *name,
        wl_array *value)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->qtam_extension_object)) {
            return;
        }
        static_cast<qtam_extension *>(r->qtam_extension_object)->qtam_extension_set_window_property(
            r,
            surface,
            QString::fromUtf8(name),
            value);
    }

    void qtam_extension::send_window_property_changed(struct ::wl_resource *surface, const QString &name, const QByteArray &value)
    {
        Q_ASSERT_X(m_resource, "qtam_extension::window_property_changed", "Uninitialised resource");
        if (Q_UNLIKELY(!m_resource)) {
            qWarning("could not call qtam_extension::window_property_changed as it's not initialised");
            return;
        }
        send_window_property_changed(
            m_resource->handle,
            surface,
            name,
            value);
    }

    void qtam_extension::send_window_property_changed(struct ::wl_resource *resource, struct ::wl_resource *surface, const QString &name, const QByteArray &value)
    {
        struct wl_array value_data;
        value_data.size = value.size();
        value_data.data = static_cast<void *>(const_cast<char *>(value.constData()));
        value_data.alloc = 0;

        qtam_extension_send_window_property_changed(
            resource,
            surface,
            name.toUtf8().constData(),
            &value_data);
    }

}

QT_WARNING_POP
QT_END_NAMESPACE
