// This file was generated by qtwaylandscanner
// source file is /builddir/build/BUILD/qtapplicationmanager-5.15.1_QtAS/src/wayland-extensions/qtam-extension.xml

#ifndef QT_WAYLAND_SERVER_QTAM_EXTENSION
#define QT_WAYLAND_SERVER_QTAM_EXTENSION

#include "wayland-server-core.h"
#include <QtAppManWindow/private/wayland-qtam-extension-server-protocol.h>
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

#if !defined(Q_WAYLAND_SERVER_QTAM_EXTENSION_EXPORT)
#  if defined(QT_SHARED)
#    define Q_WAYLAND_SERVER_QTAM_EXTENSION_EXPORT Q_DECL_EXPORT
#  else
#    define Q_WAYLAND_SERVER_QTAM_EXTENSION_EXPORT
#  endif
#endif

namespace QtWaylandServer {
    class Q_WAYLAND_SERVER_QTAM_EXTENSION_EXPORT qtam_extension
    {
    public:
        qtam_extension(struct ::wl_client *client, int id, int version);
        qtam_extension(struct ::wl_display *display, int version);
        qtam_extension(struct ::wl_resource *resource);
        qtam_extension();

        virtual ~qtam_extension();

        class Resource
        {
        public:
            Resource() : qtam_extension_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            qtam_extension *qtam_extension_object;
            qtam_extension *object() { return qtam_extension_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_window_property_changed(struct ::wl_resource *surface, const QString &name, const QByteArray &value);
        void send_window_property_changed(struct ::wl_resource *resource, struct ::wl_resource *surface, const QString &name, const QByteArray &value);

    protected:
        virtual Resource *qtam_extension_allocate();

        virtual void qtam_extension_bind_resource(Resource *resource);
        virtual void qtam_extension_destroy_resource(Resource *resource);

        virtual void qtam_extension_set_window_property(Resource *resource, struct ::wl_resource *surface, const QString &name, wl_array *value);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::qtam_extension_interface m_qtam_extension_interface;

        static void handle_set_window_property(
            ::wl_client *client,
            struct wl_resource *resource,
            struct ::wl_resource *surface,
            const char *name,
            wl_array *value);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            qtam_extension *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
